﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using STFXmlParser;

namespace Selections
{
    public class BoxSelections
    {
        // This holds selected boxes until we process them for an operation.
        public List<BoxSelect> boxSelBuff = new List<BoxSelect>();

        // Put something in for operator locking and box format setting...
        // Ex: operator lock on '+', box format is '.to_f(), so main form
        // needs only to check these values without even bringing up the
        // tool belt and showing the Box Selection tab page. It will need to 
        // bring up the tool belt for multiple box selections with no
        // operator locking in place.


        /*
         * Boxes in the boxSelBuff are formatted if appropriate and
         * sent on the Vscode via ctClient. Formatting involves 
         * individual box formatting like applying .to_f() for example
         * as well as applying say a mathematical operator for multiple
         * box selections, or say setting up a comma delimited string
         * of boxes, whatever the user has set for box selections.
         */
        public void ProcessSelections()
        {

        }


    }

    public class DocCalcs
    {
        public string calcLinkFile { get; set; }

        private Dictionary<string, CalcField> _CalcDict;
        private List<CodeBlock> _CodeList;

        public DocCalcs(string linkFile)
        {
            calcLinkFile = linkFile;
            _CalcDict = new Dictionary<string, CalcField>();
            _CodeList = new List<CodeBlock>();
        }

        public int NumCalcs()
        {
            return _CalcDict.Count;
        }

        public int NumCodeBlocks()
        {
            return _CodeList.Count;
        }
    }

    public class CalcField
    {
        // pa [page array] index of calculated box.
        public int calcPaIndex { get; set; }

        // fa [field array] index for the page of the calculated box.
        public int calcFaIndex { get; set; }

        // index in the _CodeList of the associated code block.
        public int codeBlkIndex { get; set; }

        /*
         * fa indices for the boxes referenced by the calc field.
         * The key is a page number as calcs can reference boxes on
         * multiple pages.
        */
        public Dictionary<int, List<int>> refIndex { get; set; }
    }

    public class CodeBlock
    {
        public string calcCode { get; set; }

        // All of the calculated boxes in the code block. These are keys to 
        // the _CalcDict. NOT SURE IF THIS WILL BE USED.
        public List<string> calcBoxes { get; set; }
    }

    //public class BoxSelect
    //{
    //    public string box { get; set; }
    //    public int paIndex { get; set; }
    //    public int faIndex { get; set; }

    //    /*
    //     * The default for this is 'true' indicating this box has
    //     * been selected, however, it may also be un-selected by
    //     * the user. For example, they incorrectly selected a box
    //     * for inclusion in a calculation, so this will be 'false'.
    //    */
    //    //public bool select { get; set; }

    //    public BoxSelect(string boxSel, int paIndx, int faIndx)
    //    {
    //        box = boxSel;
    //        paIndex = paIndx;
    //        faIndex = faIndx;
    //        //select = true;
    //    }
    //}

}